首页 > 代码库 > LeetCode: Gas Station 解题报告
LeetCode: Gas Station 解题报告
Gas Station
There are N gas stations along a circular route, where the amount of gas at station i is gas[i].
You have a car with an unlimited gas tank and it costs cost[i] of gas to travel from station i to its next station (i+1). You begin the journey with an empty tank at one of the gas stations.
Return the starting gas station‘s index if you can travel around the circuit once, otherwise return -1.
Note:
The solution is guaranteed to be unique.
Greedy
SOLUTION 1:
引自Lexi‘s Leetcode solutions 的解答:
- 从i开始,j是当前station的指针,sum += gas[j] – cost[j] (从j站加了油,再算上从i开始走到j剩的油,走到j+1站还能剩下多少油)
- 如果sum < 0,说明从i开始是不行的。那能不能从i..j中间的某个位置开始呢?既然i出发到i+1是可行的, 又i~j是不可行的, 从而发现i+1~ j是不可行的。
- 以此类推i+2~j, i+3~j,i+4~j 。。。。等等都是不可行的
- 所以一旦sum<0,index就赋成j + 1,sum归零。
- 最后total表示能不能走一圈。
以上做法,其实是贪心的思想:
也就是说brute force的解是 : 一个一个来考虑, 每一个绕一圈, 但是 实际上 我们发现 i - j不可行 直接index就跳到j+1, 这样周而复始,很快就是绕一圈 就得到解了。
1 public class Solution { 2 public int canCompleteCircuit(int[] gas, int[] cost) { 3 if (gas == null || cost == null || gas.length == 0 || cost.length == 0) { 4 // Bug 0: should not return false; 5 return -1; 6 } 7 8 int total = 0; 9 int sum = 0;10 11 int startIndex = 0;12 13 int len = gas.length;14 for (int i = 0; i < len; i++) {15 int dif = gas[i] - cost[i];16 sum += dif;17 18 if (sum < 0) {19 // Means that from 0 to this gas station, none of them can be the solution.20 startIndex = i + 1; // Begin from the next station.21 sum = 0; // reset the sum.22 }23 24 total += dif;25 }26 27 if (total < 0) {28 return -1;29 }30 31 return startIndex;32 }33 }
GITHUB:
https://github.com/yuzhangcmu/LeetCode_algorithm/blob/master/greedy/CanCompleteCircuit.java
LeetCode: Gas Station 解题报告
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。